﻿// -----------------------------------------------------------------------
// <copyright file="MockDbAccessor.cs" company="">
// TODO: Update copyright text.
// </copyright>
// -----------------------------------------------------------------------

namespace Business.Test.Mock
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using Business.Facade;
    using Business.Model;

    /// <summary>
    /// TODO: Update summary.
    /// </summary>
    public class MockDbAccessor : IDbAccessor
    {
        private HashSet<LogRecord> logs = new HashSet<LogRecord>();

        public bool CreateLog(LogRecord log)
        {
            this.logs.Add(log);

            return true;
        }

        public bool UpdateLog(LogRecord log)
        {
            this.logs.RemoveWhere(l => l.Id == log.Id);

            this.logs.Add(log);

            return true;
        }

        public LogRecord GetLogById(Guid id)
        {
            return this.logs.SingleOrDefault(l => l.Id == id);
        }

        public bool DeleteLog(Guid logId)
        {
            this.logs.RemoveWhere(l => l.Id == logId);

            return true;
        }

        public IEnumerable<LogRecord> GetUncompleteRecords()
        {
            return this.logs.Where(l => !l.IsCompleted && l.OrderId.HasValue);
        }

        public IEnumerable<LogRecord> GetAllRecord()
        {
            return this.logs.AsEnumerable();
        }

        public LogRecord GetLogByTaskId(Guid taskId)
        {
            return this.logs.SingleOrDefault(l => l.TaskId == taskId);
        }
    }
}
