﻿// -----------------------------------------------------------------------
// <copyright file="MockOrderSystem.cs" company="">
// TODO: Update copyright text.
// </copyright>
// -----------------------------------------------------------------------

namespace Business.Test.Mock
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using Business.Facade;
    using Business.Model;
    using Common;

    /// <summary>
    /// TODO: Update summary.
    /// </summary>
    public class MockOrderSystem : IOrderSystem
    {
        private HashSet<Order> orders = new HashSet<Order>();

        public Guid CreateOrder(Order order)
        {
            order.Id = Guid.NewGuid();

            this.orders.Add(order);

            return order.Id;
        }

        public OrderStatus GetOrderStatus(Guid orderId)
        {
            Order order = this.orders.SingleOrDefault(o => o.Id == orderId);

            if (order != null)
            {
                order.Status = GenerateOrderStatus();

                if (order.Status == OrderStatus.Finish)
                {
                    order.Money = RandomValueGenerator.GenerateRandomNumber(50, 500);
                }

                return order.Status;
            }

            return OrderStatus.NotExist;
        }

        public IEnumerable<Order> GetAllOrders()
        {
            return this.orders.AsEnumerable();
        }

        private OrderStatus GenerateOrderStatus()
        {
            int v = RandomValueGenerator.GenerateRandomNumber(2, 3);

            if (v == 2)
            {
                return OrderStatus.Processing;
            }

            return OrderStatus.Finish;
        }
    }
}
