﻿// -----------------------------------------------------------------------
// <copyright file="MockTaskSystem.cs" company="">
// TODO: Update copyright text.
// </copyright>
// -----------------------------------------------------------------------

namespace Business.Test.Mock
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using Business.Facade;
    using Business.Model;
    using Common;

    /// <summary>
    /// TODO: Update summary.
    /// </summary>
    public class MockTaskSystem : ITaskSystem
    {
        private HashSet<Task> tasks = new HashSet<Task>();

        public Guid CreateTask(Task task)
        {
            task.Id = Guid.NewGuid();
            task.NeedCreateOrder = RandomValueGenerator.GenerateBooleanValue();
            task.Status = TaskStatus.Processing;

            this.tasks.Add(task);

            return task.Id;
        }

        public bool UpdateTask(Task task)
        {
            Task delTask = this.tasks.SingleOrDefault(t => t.Id == task.Id);

            if (delTask != null)
            {
                this.tasks.Remove(delTask);

                this.tasks.Add(task);

                return true;
            }

            return false;
        }

        public IEnumerable<Task> GetTasks(Guid[] ids)
        {
            return this.tasks.Where(t => ids.Contains(t.Id));
        }

        public IEnumerable<Task> GetNeedCreateOrderTasks()
        {
            return this.tasks.Where(t => t.NeedCreateOrder);
        }

        public IEnumerable<Task> GetAllTasks()
        {
            return this.tasks.AsEnumerable();
        }

        public void InitializeTasks(IEnumerable<Task> initialTasks)
        { 
            this.tasks.Clear();

            foreach (var task in initialTasks)
            {
                this.tasks.Add(task);
            }
        }
    }
}
