﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Business.Model;
using Common;

namespace Business.Test
{
    [TestClass]
    public class OrderCreatorTest : TestBase
    {
        [TestMethod]
        public void TestCreateOrder()
        {
            InitializeTaskSystem();

            new ConcreateOrderCreator(sourceReader, taskSystem, orderSystem, dbAccessor).CreateOrder();

            IEnumerable<Task> needCreateOrderTasks = taskSystem.GetNeedCreateOrderTasks();
            IEnumerable<Order> createdOrders = orderSystem.GetAllOrders();

            Assert.AreEqual(needCreateOrderTasks.Count(), createdOrders.Count());

            foreach (var task in needCreateOrderTasks)
            {
                Order order = createdOrders.SingleOrDefault(o => o.ReaderId == task.ReaderId);
                Assert.IsNotNull(order);
                Assert.AreEqual(task.OrderId, order.Id);

                LogRecord record = dbAccessor.GetLogByTaskId(task.Id);
                Assert.IsNotNull(record);
                Assert.AreEqual(task.OrderId, record.OrderId);
                Assert.IsNotNull(record.OrderCreated);
                Assert.AreEqual(record.Address, order.Address);
            }
        }
    }
}
