﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Business.Facade;
using Business.Test.Mock;
using Business.Model;
using Common;

namespace Business.Test
{
    [TestClass]
    public class TaskCreatorTest : TestBase
    {
        [TestMethod]
        public void TestCreateTask()
        {
            InitializeSourceReader();
            IEnumerable<ReaderData> readerData = sourceReader.GetReaderData();
            int readerDataCount = readerData.Count();


            var taskCreator = new ConcreteTaskCreator(sourceReader, taskSystem, dbAccessor);
            taskCreator.CreateTask();


            IEnumerable<Task> createdTasks = taskSystem.GetAllTasks();
            Assert.AreEqual(readerDataCount, createdTasks.Count());

            IEnumerable<LogRecord> records = dbAccessor.GetAllRecord();
            Assert.AreEqual(readerDataCount, records.Count());

            foreach (var readerItem in readerData)
            {
                Assert.IsTrue(createdTasks.Any(t => t.ReaderId == readerItem.Id && t.Status != TaskStatus.Completed));
                Assert.IsTrue(records.Any(t => t.ReaderId == readerItem.Id && t.Address == readerItem.Address && t.TaskCreated.HasValue && !t.IsCompleted));
            }
        }
    }
}
