﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Business.Model;

namespace Business.Test
{
    [TestClass]
    public class TaskUpdaterTest : TestBase
    {
        [TestMethod]
        public void TestUpdateTask()
        {
            InitializeOrderSystem();

            new ConcreateTaskUpdater(taskSystem, orderSystem, dbAccessor).UpdateTask();

            IEnumerable<Order> orders = orderSystem.GetAllOrders();
            IEnumerable<Task> tasks = taskSystem.GetAllTasks();
            IEnumerable<LogRecord> records = dbAccessor.GetAllRecord();

            foreach (var o in orders)
            {
                Task task = tasks.SingleOrDefault(t => t.OrderId == o.Id);

                Assert.IsNotNull(task);
                Assert.AreEqual(task.Status, Utility.ConvertToTaskStatus(o.Status));

                LogRecord record = records.SingleOrDefault(r => r.OrderId == o.Id);
                Assert.IsNotNull(record);
                Assert.AreEqual(record.OrderStatus, o.Status);

                if (o.Status == OrderStatus.Finish)
                {
                    Assert.IsTrue(record.IsCompleted);
                }
            }
        }
    }
}
