﻿// -----------------------------------------------------------------------
// <copyright file="ConcreateTaskUpdater.cs" company="">
// TODO: Update copyright text.
// </copyright>
// -----------------------------------------------------------------------

namespace Business
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using Business.Facade;
    using Business.Model;

    /// <summary>
    /// TODO: Update summary.
    /// </summary>
    public class ConcreateTaskUpdater : ITaskUpdater
    {
        private readonly ITaskSystem taskSystem;

        private readonly IOrderSystem orderSystem;

        private readonly IDbAccessor dbAccessor;

        public ConcreateTaskUpdater(ITaskSystem taskSystem, IOrderSystem orderSystem, IDbAccessor dbAccessor)
        {
            this.taskSystem = taskSystem;
            this.orderSystem = orderSystem;
            this.dbAccessor = dbAccessor;
        }

        public void UpdateTask()
        {
            IEnumerable<LogRecord> uncompletedRecords = dbAccessor.GetUncompleteRecords();

            foreach (var record in uncompletedRecords)
            {
                OrderStatus orderStatus = orderSystem.GetOrderStatus(record.OrderId.Value);
                if (orderStatus != OrderStatus.NotExist && orderStatus != record.OrderStatus)
                {
                    Task task = taskSystem.GetTasks(new Guid[] { record.TaskId }).First();
                    task.Status = Utility.ConvertToTaskStatus(orderStatus);
                    taskSystem.UpdateTask(task);


                    record.OrderStatus = orderStatus;
                    if (orderStatus == OrderStatus.Finish)
                    {
                        record.IsCompleted = true;
                    }
                    dbAccessor.UpdateLog(record);
                }
            }
        }
    }
}
