﻿// -----------------------------------------------------------------------
// <copyright file="ConcreteTaskCreator.cs" company="">
// TODO: Update copyright text.
// </copyright>
// -----------------------------------------------------------------------

namespace Business
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using Business.Facade;
    using Business.Model;

    /// <summary>
    /// TODO: Update summary.
    /// </summary>
    public class ConcreteTaskCreator : ITaskCreator
    {
        private readonly ISourceReader sourceReader;

        private readonly ITaskSystem taskSystem;

        private readonly IDbAccessor dbAccessor;

        public ConcreteTaskCreator(ISourceReader reader, ITaskSystem taskSystem, IDbAccessor accessor)
        {
            this.sourceReader = reader;
            this.taskSystem = taskSystem;
            this.dbAccessor = accessor;
        }

        public void CreateTask()
        {
            IEnumerable<ReaderData> dataSource = sourceReader.GetReaderData();

            if (dataSource != null)
            {
                IEnumerable<LogRecord> uncompleteTasks = dbAccessor.GetUncompleteRecords();

                IEnumerable<Guid> uncompleteTaskReaderIds = uncompleteTasks.Select(t => t.ReaderId);

                foreach (ReaderData d in dataSource)
                {
                    if (!uncompleteTaskReaderIds.Contains(d.Id))
                    {
                        Task newTask = new Task();
                        newTask.ReaderId = d.Id;
                        newTask.CreateDate = DateTime.Now;

                        Guid taskId = taskSystem.CreateTask(newTask);

                        if (taskId != Guid.Empty)
                        {
                            newTask.Id = taskId;

                            LogRecord log = Utility.GetNewLogRecord(newTask, d);

                            dbAccessor.CreateLog(log);
                        }
                    }
                }
            }
        }
    }
}
