﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Common
{
    public class RandomValueGenerator
    {
        public static int GenerateRandomNumber(int min, int max)
        {
            var ran = new Random();
            return ran.Next(min, max);
        }

        public static bool GenerateBooleanValue()
        {
            return GenerateRandomNumber(0, 1) == 1;
        }

        public static string GenerateRandomString(int length, bool useNumber, bool useLowerCase, bool useUpperCase, bool useSpecificSymbol, string custom = "")
        {
            byte[] b = new byte[4];
            new System.Security.Cryptography.RNGCryptoServiceProvider().GetBytes(b);
            Random r = new Random(BitConverter.ToInt32(b, 0));
            string s = null, str = custom;

            if (useNumber) { str += "0123456789"; }
            if (useLowerCase) { str += "abcdefghijklmnopqrstuvwxyz"; }
            if (useUpperCase) { str += "ABCDEFGHIJKLMNOPQRSTUVWXYZ"; }
            if (useSpecificSymbol) { str += "!\"#$%&'()*+,-./:;<=>?@[\\]^_`{|}~"; }

            for (int i = 0; i < length; i++)
            {
                s += str.Substring(r.Next(0, str.Length - 1), 1);
            }

            return s;
        }
    }
}
