﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using Common;

namespace OASystemService
{
    /// <summary>
    /// Summary description for OAService
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [System.ComponentModel.ToolboxItem(false)]
    // To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
    // [System.Web.Script.Services.ScriptService]
    public class OAService : System.Web.Services.WebService
    {
        private Dictionary<Guid, OATask> tasks = new Dictionary<Guid, OATask>();

        [WebMethod]
        public Guid CreateTask(OATask task)
        {
            task.Id = Guid.NewGuid();
            task.Status = OATaskStatus.NotStart;
            task.NeedCreateOrder = RandomValueGenerator.GenerateBooleanValue();

            this.tasks.Add(task.Id, task);

            return task.Id;
        }

        [WebMethod]
        public bool UpdateTask(OATask task)
        {
            this.tasks.Remove(task.Id);

            this.tasks.Add(task.Id, task);

            return true;
        }

        [WebMethod]
        public IEnumerable<OATask> GetTasks(Guid[] ids)
        {
            var result = new List<OATask>();

            foreach (Guid id in ids)
            {
                if (this.tasks.ContainsKey(id))
                {
                    OATask task = this.tasks[id];

                    task.Status = GenerateTaskStatus();

                    result.Add(task);
                }
            }

            return result.AsEnumerable();
        }

        private OATaskStatus GenerateTaskStatus()
        {
            int v = RandomValueGenerator.GenerateRandomNumber(2, 3);

            if (v == 2)
            {
                return OATaskStatus.Processing;
            }

            return OATaskStatus.Completed;
        }
    }
}
