﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using Common;

namespace OrderService
{
    /// <summary>
    /// Summary description for OrderService
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [System.ComponentModel.ToolboxItem(false)]
    // To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
    // [System.Web.Script.Services.ScriptService]
    public class OrderService : System.Web.Services.WebService
    {
        private Dictionary<Guid, Order> orders = new Dictionary<Guid, Order>();

        [WebMethod]
        public Guid CreateOrder(Order order)
        {
            order.Id = Guid.NewGuid();
            order.Status = OrderStatus.New;

            this.orders.Add(order.Id, order);

            return order.Id;
        }

        [WebMethod]
        public OrderStatus GetOrderStatus(Guid orderId)
        {
            if (this.orders.ContainsKey(orderId))
            {
                OrderStatus status = GenerateOrderStatus();

                Order order = this.orders[orderId];

                order.Status = status;

                if (status == OrderStatus.Finish)
                {
                    order.Money = RandomValueGenerator.GenerateRandomNumber(50, 500);
                }

                return status;
            }

            return OrderStatus.NotExist;
        }

        private OrderStatus GenerateOrderStatus()
        {
            int v = RandomValueGenerator.GenerateRandomNumber(2, 3);

            if (v == 2)
            {
                return OrderStatus.Processing;
            }

            return OrderStatus.Finish;
        }
    }
}
